module TalltyImportExport
  module Attr
    class ExportHeaderItem
      include AttrJson::Model
      attr_json_config(bad_cast: :as_nil, unknown_key: :allow)

      attr_json :key, :string
      attr_json :name, :string
      attr_json :attr_type, :string
      attr_json :format, :string
      attr_json :method, :string
      attr_json :chain, :string, array: true
      attr_json :merge, :boolean
      attr_json :json, :string
      attr_json :select, ActiveModel::Type::Value.new, array: true
      attr_json :source, :boolean
      attr_json :proc, ActiveModel::Type::Value.new, array: true
      attr_json :children, self.to_type, array: true

      attr_accessor :depth, :parent_path, :seq

      def calcute_flatten_value _depth, _parent_path
        @depth = _depth
        @parent_path = _parent_path
        if children
          children.map do |child|
            child.calcute_flatten_value(_depth + 1, [*_parent_path, self])
          end.compact.flatten
        else
          [self]
        end
      end

      def cluster_seqs
        calcute_flatten_value(0, []).map(&:seq)
      end

      def seq
        @seq ||= SecureRandom.uuid
      end

      # def living_alone?
      #   depth == 0 && children.present?
      # end
    end

    class ExportHeader
      include AttrJson::Model
      attr_json_config(bad_cast: :as_nil, unknown_key: :allow)

      attr_json :items, ExportHeaderItem.to_type, array: true

      def flatten_value
        items.map do |item|
          item.calcute_flatten_value(0, [])
        end.flatten
      end
    end
  end
end
